Index: trunk/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 2528)
@@ -7,6 +7,6 @@
    !!                 ! 1997-07  (G. Madec)  lbc_lnk call
    !!                 ! 1997-04  (J.-O. Beismann) 
-   !!            8.5  ! 2002-09 (A. Bozec, G. Madec)  F90: Free form and module
-   !!             -   ! 2002-09 (A. de Miranda)  rigid-lid + islands
+   !!            8.5  ! 2002-09  (A. Bozec, G. Madec)  F90: Free form and module
+   !!             -   ! 2002-09  (A. de Miranda)  rigid-lid + islands
    !!  NEMO      1.0  ! 2003-08  (G. Madec)  F90: Free form and module
    !!             -   ! 2005-10  (A. Beckmann)  modifications for hybrid s-ccordinates & new stretching function
@@ -14,4 +14,5 @@
    !!            3.0  ! 2008-06  (G. Madec)  insertion of domzgr_zps.h90 & conding style
    !!            3.2  ! 2009-07  (R. Benshila) Suppression of rigid-lid option
+   !!            3.3  ! 2010-11  (G. Madec) add mbk. arrays associated to the deepest ocean level
    !!----------------------------------------------------------------------
 
@@ -21,4 +22,5 @@
    !!       zgr_bat_zoom : modify the bathymetry field if zoom domain
    !!       zgr_bat_ctl  : check the bathymetry files
+   !!       zgr_bot_level: deepest ocean level for t-, u, and v-points
    !!       zgr_z        : reference z-coordinate 
    !!       zgr_zco      : z-coordinate 
@@ -28,28 +30,28 @@
    !!       dfssig       : derivative of the sigma coordinate function    !!gm  (currently missing!)
    !!---------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! distributed memory computing library
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE closea          ! closed seas
-   USE c1d             ! 1D configuration
+   USE oce               ! ocean variables
+   USE dom_oce           ! ocean domain
+   USE closea            ! closed seas
+   USE c1d               ! 1D vertical configuration
+   USE in_out_manager    ! I/O manager
+   USE iom               ! I/O library
+   USE lbclnk            ! ocean lateral boundary conditions (or mpp link)
+   USE lib_mpp           ! distributed memory computing library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   dom_zgr    ! called by dom_init.F90
-
-!!gm   DOCTOR name for the namelist parameter...
-   !                                    !!! ** Namelist namzgr_sco **
-   REAL(wp) ::   rn_sbot_min =  300.     ! minimum depth of s-bottom surface (>0) (m)
-   REAL(wp) ::   rn_sbot_max = 5250.     ! maximum depth of s-bottom surface (= ocean depth) (>0) (m)
-   REAL(wp) ::   rn_theta    =    6.0    ! surface control parameter (0<=rn_theta<=20)
-   REAL(wp) ::   rn_thetb    =    0.75   ! bottom control parameter  (0<=rn_thetb<= 1)
-   REAL(wp) ::   rn_rmax     =    0.15   ! maximum cut-off r-value allowed (0<rn_rmax<1)
-   LOGICAL  ::   ln_s_sigma  = .false.   ! use hybrid s-sigma -coordinate & stretching function fssig1 (ln_sco=T)
-   REAL(wp) ::   rn_bb       =    0.8    ! stretching parameter for song and haidvogel stretching
-   !                                     ! ( rn_bb=0; top only, rn_bb =1; top and bottom)
-   REAL(wp) ::   rn_hc       = 150.      ! Critical depth for s-sigma coordinates
+   PUBLIC   dom_zgr      ! called by dom_init.F90
+
+   !                                       !!* Namelist namzgr_sco *
+   REAL(wp) ::   rn_sbot_min =  300._wp     ! minimum depth of s-bottom surface (>0) (m)
+   REAL(wp) ::   rn_sbot_max = 5250._wp     ! maximum depth of s-bottom surface (= ocean depth) (>0) (m)
+   REAL(wp) ::   rn_theta    =    6.00_wp   ! surface control parameter (0<=rn_theta<=20)
+   REAL(wp) ::   rn_thetb    =    0.75_wp   ! bottom control parameter  (0<=rn_thetb<= 1)
+   REAL(wp) ::   rn_rmax     =    0.15_wp   ! maximum cut-off r-value allowed (0<rn_rmax<1)
+   LOGICAL  ::   ln_s_sigma  = .false.      ! use hybrid s-sigma -coordinate & stretching function fssig1 (ln_sco=T)
+   REAL(wp) ::   rn_bb       =    0.80_wp   ! stretching parameter for song and haidvogel stretching
+   !                                        ! ( rn_bb=0; top only, rn_bb =1; top and bottom)
+   REAL(wp) ::   rn_hc       =  150._wp     ! Critical depth for s-sigma coordinates
  
    !! * Substitutions
@@ -57,9 +59,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS       
 
@@ -75,5 +76,5 @@
       !!              - vertical coordinate (gdep., e3.) depending on the 
       !!                coordinate chosen :
-      !!                   ln_zco=T   z-coordinate   (forced if lk_zco)
+      !!                   ln_zco=T   z-coordinate   
       !!                   ln_zps=T   z-coordinate with partial steps
       !!                   ln_zco=T   s-coordinate 
@@ -82,10 +83,10 @@
       !!----------------------------------------------------------------------
       INTEGER ::   ioptio = 0   ! temporary integer
-      !!
+      !
       NAMELIST/namzgr/ ln_zco, ln_zps, ln_sco
       !!----------------------------------------------------------------------
 
-      REWIND ( numnam )                ! Read Namelist namzgr : vertical coordinate'
-      READ   ( numnam, namzgr )
+      REWIND( numnam )                 ! Read Namelist namzgr : vertical coordinate'
+      READ  ( numnam, namzgr )
 
       IF(lwp) THEN                     ! Control print
@@ -103,25 +104,21 @@
       IF( ln_zps ) ioptio = ioptio + 1
       IF( ln_sco ) ioptio = ioptio + 1
-      IF ( ioptio /= 1 )   CALL ctl_stop( ' none or several vertical coordinate options used' )
-      IF( lk_zco ) THEN
-          IF(lwp) WRITE(numout,*) '          z-coordinate with reduced incore memory requirement'
-          IF( ln_zps .OR. ln_sco )   CALL ctl_stop( ' reduced memory with zps or sco option is impossible' )
-      ENDIF
-
+      IF( ioptio /= 1 )   CALL ctl_stop( ' none or several vertical coordinate options used' )
+      !
       ! Build the vertical coordinate system
       ! ------------------------------------
-                     CALL zgr_z        ! Reference z-coordinate system (always called)
-                     CALL zgr_bat      ! Bathymetry fields (levels and meters)
-      IF( ln_zco )   CALL zgr_zco      ! z-coordinate
-      IF( ln_zps )   CALL zgr_zps      ! Partial step z-coordinate
-      IF( ln_sco )   CALL zgr_sco      ! s-coordinate or hybrid z-s coordinate
-      !
-     ! final adjustment of mbathy & check
-     ! -----------------------------------
-     IF( lzoom       )   CALL zgr_bat_zoom     ! correct mbathy in case of zoom subdomain
-     IF( .NOT.lk_c1d )   CALL zgr_bat_ctl      ! check bathymetry (mbathy) and suppress isoated ocean points
-
-
-!!bug gm control print:
+                          CALL zgr_z            ! Reference z-coordinate system (always called)
+                          CALL zgr_bat          ! Bathymetry fields (levels and meters)
+      IF( ln_zco      )   CALL zgr_zco          ! z-coordinate
+      IF( ln_zps      )   CALL zgr_zps          ! Partial step z-coordinate
+      IF( ln_sco      )   CALL zgr_sco          ! s-coordinate or hybrid z-s coordinate
+      !
+      ! final adjustment of mbathy & check 
+      ! -----------------------------------
+      IF( lzoom       )   CALL zgr_bat_zoom     ! correct mbathy in case of zoom subdomain
+      IF( .NOT.lk_c1d )   CALL zgr_bat_ctl      ! check bathymetry (mbathy) and suppress isoated ocean points
+                          CALL zgr_bot_level    ! deepest ocean level for t-, u- and v-points
+      !
+      !
       IF( nprint == 1 .AND. lwp )   THEN
          WRITE(numout,*) ' MIN val mbathy ', MINVAL( mbathy(:,:) ), ' MAX ', MAXVAL( mbathy(:,:) )
@@ -140,6 +137,5 @@
             &                   ' w ',   MAXVAL( fse3w(:,:,:) )
       ENDIF
-!!!bug gm
-
+      !
    END SUBROUTINE dom_zgr
 
@@ -171,4 +167,5 @@
       REAL(wp) ::   zacr, zdzmin, zhmax    ! par_CONFIG_Rxx.h90
       REAL(wp) ::   zrefdep                ! depth of the reference level (~10m)
+      REAL(wp) ::   za2, zkth2, zacr2      ! Values for optional double tanh function set from parameters 
       !!----------------------------------------------------------------------
 
@@ -177,8 +174,8 @@
        zkth = ppkth       ;   zacr = ppacr
        zdzmin = ppdzmin   ;   zhmax = pphmax
+       zkth2 = ppkth2     ;   zacr2 = ppacr2   ! optional (ldbletanh=T) double tanh parameters
 
       ! If ppa1 and ppa0 and ppsur are et to pp_to_be_computed
       !  za0, za1, zsur are computed from ppdzmin , pphmax, ppkth, ppacr
-      !
       IF(   ppa1  == pp_to_be_computed  .AND.  &
          &  ppa0  == pp_to_be_computed  .AND.  &
@@ -192,4 +189,5 @@
       ELSE
          za1 = ppa1 ;       za0 = ppa0 ;          zsur = ppsur
+         za2 = ppa2                            ! optional (ldbletanh=T) double tanh parameter
       ENDIF
 
@@ -198,10 +196,10 @@
          WRITE(numout,*) '    zgr_z   : Reference vertical z-coordinates'
          WRITE(numout,*) '    ~~~~~~~'
-         IF(  ppkth == 0. ) THEN              
+         IF(  ppkth == 0._wp ) THEN              
               WRITE(numout,*) '            Uniform grid with ',jpk-1,' layers'
               WRITE(numout,*) '            Total depth    :', zhmax
               WRITE(numout,*) '            Layer thickness:', zhmax/(jpk-1)
          ELSE
-            IF( ppa1 == 0. .AND. ppa0 == 0. .AND. ppsur == 0. ) THEN
+            IF( ppa1 == 0._wp .AND. ppa0 == 0._wp .AND. ppsur == 0._wp ) THEN
                WRITE(numout,*) '         zsur, za0, za1 computed from '
                WRITE(numout,*) '                 zdzmin = ', zdzmin
@@ -214,4 +212,9 @@
             WRITE(numout,*) '                 zkth = ', zkth
             WRITE(numout,*) '                 zacr = ', zacr
+            IF( ldbletanh ) THEN
+               WRITE(numout,*) ' (Double tanh    za2  = ', za2
+               WRITE(numout,*) '  parameters)    zkth2= ', zkth2
+               WRITE(numout,*) '                 zacr2= ', zacr2
+            ENDIF
          ENDIF
       ENDIF
@@ -220,9 +223,9 @@
       ! Reference z-coordinate (depth - scale factor at T- and W-points)
       ! ======================
-      IF( ppkth == 0.e0 ) THEN            !  uniform vertical grid       
+      IF( ppkth == 0._wp ) THEN            !  uniform vertical grid       
          za1 = zhmax / FLOAT(jpk-1) 
          DO jk = 1, jpk
             zw = FLOAT( jk )
-            zt = FLOAT( jk ) + 0.5
+            zt = FLOAT( jk ) + 0.5_wp
             gdepw_0(jk) = ( zw - 1 ) * za1
             gdept_0(jk) = ( zt - 1 ) * za1
@@ -231,20 +234,36 @@
          END DO
       ELSE                                ! Madec & Imbard 1996 function
-         DO jk = 1, jpk
-            zw = FLOAT( jk )
-            zt = FLOAT( jk ) + 0.5
-            gdepw_0(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth) / zacr ) )  )
-            gdept_0(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth) / zacr ) )  )
-            e3w_0  (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
-            e3t_0  (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
-         END DO
-         gdepw_0(1) = 0.e0                     ! force first w-level to be exactly at zero
+         IF( .NOT. ldbletanh ) THEN
+            DO jk = 1, jpk
+               zw = REAL( jk , wp )
+               zt = REAL( jk , wp ) + 0.5_wp
+               gdepw_0(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth) / zacr ) )  )
+               gdept_0(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth) / zacr ) )  )
+               e3w_0  (jk) =          za0      + za1        * TANH(       (zw-zkth) / zacr   )
+               e3t_0  (jk) =          za0      + za1        * TANH(       (zt-zkth) / zacr   )
+            END DO
+         ELSE
+            DO jk = 1, jpk
+               zw = FLOAT( jk )
+               zt = FLOAT( jk ) + 0.5_wp
+               ! Double tanh function
+               gdepw_0(jk) = ( zsur + za0 * zw + za1 * zacr * LOG ( COSH( (zw-zkth ) / zacr  ) )    &
+                  &                            + za2 * zacr2* LOG ( COSH( (zw-zkth2) / zacr2 ) )  )
+               gdept_0(jk) = ( zsur + za0 * zt + za1 * zacr * LOG ( COSH( (zt-zkth ) / zacr  ) )    &
+                  &                            + za2 * zacr2* LOG ( COSH( (zt-zkth2) / zacr2 ) )  )
+               e3w_0  (jk) =          za0      + za1        * TANH(       (zw-zkth ) / zacr  )    &
+                  &                            + za2        * TANH(       (zw-zkth2) / zacr2 )
+               e3t_0  (jk) =          za0      + za1        * TANH(       (zt-zkth ) / zacr  )    &
+                  &                            + za2        * TANH(       (zt-zkth2) / zacr2 )
+            END DO
+         ENDIF
+         gdepw_0(1) = 0._wp                    ! force first w-level to be exactly at zero
       ENDIF
 
 !!gm BUG in s-coordinate this does not work!
-      ! deepest/shallowest W level Above/Bellow ~10m
-      zrefdep = 10. - ( 0.1*MINVAL(e3w_0) )                          ! ref. depth with tolerance (10% of minimum layer thickness)
-      nlb10 = MINLOC( gdepw_0, mask = gdepw_0 > zrefdep, dim = 1 )   ! shallowest W level Bellow ~10m
-      nla10 = nlb10 - 1                                              ! deepest    W level Above  ~10m
+      ! deepest/shallowest W level Above/Below ~10m
+      zrefdep = 10._wp - 0.1_wp * MINVAL( e3w_0 )                    ! ref. depth with tolerance (10% of minimum layer thickness)
+      nlb10 = MINLOC( gdepw_0, mask = gdepw_0 > zrefdep, dim = 1 )   ! shallowest W level Below ~10m
+      nla10 = nlb10 - 1                                              ! deepest    W level Above ~10m
 !!gm end bug
 
@@ -256,6 +275,6 @@
       ENDIF
       DO jk = 1, jpk                      ! control positivity
-         IF( e3w_0  (jk) <= 0.e0 .OR. e3t_0  (jk) <= 0.e0 )   CALL ctl_stop( ' e3w or e3t =< 0 '    )
-         IF( gdepw_0(jk) <  0.e0 .OR. gdept_0(jk) <  0.e0 )   CALL ctl_stop( ' gdepw or gdept < 0 ' )
+         IF( e3w_0  (jk) <= 0._wp .OR. e3t_0  (jk) <= 0._wp )   CALL ctl_stop( 'dom:zgr_z: e3w or e3t =< 0 '    )
+         IF( gdepw_0(jk) <  0._wp .OR. gdept_0(jk) <  0._wp )   CALL ctl_stop( 'dom:zgr_z: gdepw or gdept < 0 ' )
       END DO
       !
@@ -289,19 +308,14 @@
       !!      ntopo= 1 :   mbathy is read in 'bathy_level.nc' NetCDF file
       !!                   bathy  is read in 'bathy_meter.nc' NetCDF file
-      !!      C A U T I O N : mbathy will be modified during the initializa-
-      !!      tion phase to become the number of non-zero w-levels of a water
-      !!      column, with a minimum value of 1.
       !!
       !! ** Action  : - mbathy: level bathymetry (in level index)
       !!              - bathy : meter bathymetry (in meters)
       !!----------------------------------------------------------------------
-      USE iom
-      !!
       INTEGER  ::   ji, jj, jl, jk            ! dummy loop indices
       INTEGER  ::   inum                      ! temporary logical unit
       INTEGER  ::   ii_bump, ij_bump, ih      ! bump center position
-      INTEGER  ::   ii0, ii1, ij0, ij1        ! indices
+      INTEGER  ::   ii0, ii1, ij0, ij1, ik    ! local indices
       REAL(wp) ::   r_bump , h_bump , h_oce   ! bump characteristics 
-      REAL(wp) ::   zi     , zj     , zh      ! temporary scalars
+      REAL(wp) ::   zi, zj, zh, zhmin         ! local scalars
       INTEGER , DIMENSION(jpidta,jpjdta) ::   idta   ! global domain integer data
       REAL(wp), DIMENSION(jpidta,jpjdta) ::   zdta   ! global domain scalar data
@@ -328,6 +342,6 @@
             ii_bump = jpidta / 2                           ! i-index of the bump center
             ij_bump = jpjdta / 2                           ! j-index of the bump center
-            r_bump  = 50000.e0                             ! bump radius (meters)       
-            h_bump  = 2700.e0                              ! bump height (meters)
+            r_bump  = 50000._wp                            ! bump radius (meters)       
+            h_bump  =  2700._wp                            ! bump height (meters)
             h_oce   = gdepw_0(jpk)                         ! background ocean depth (meters)
             IF(lwp) WRITE(numout,*) '            bump characteristics: '
@@ -350,9 +364,5 @@
                idta(:,:) = jpkm1
                DO jk = 1, jpkm1
-                  DO jj = 1, jpjdta
-                     DO ji = 1, jpidta
-                        IF( gdept_0(jk) < zdta(ji,jj) .AND. zdta(ji,jj) <= gdept_0(jk+1) )   idta(ji,jj) = jk
-                     END DO
-                  END DO
+                  WHERE( gdept_0(jk) < zdta(:,:) .AND. zdta(:,:) <= gdept_0(jk+1) )   idta(:,:) = jk
                END DO
             ENDIF
@@ -361,13 +371,13 @@
          !                                            ! Caution : idta on the global domain: use of jperio, not nperio
          IF( jperio == 1 .OR. jperio == 4 .OR. jperio == 6 ) THEN
-            idta( :    , 1    ) = -1                ;      zdta( :    , 1    ) = -1.e0
-            idta( :    ,jpjdta) =  0                ;      zdta( :    ,jpjdta) =  0.e0
+            idta( :    , 1    ) = -1                ;      zdta( :    , 1    ) = -1._wp
+            idta( :    ,jpjdta) =  0                ;      zdta( :    ,jpjdta) =  0._wp
          ELSEIF( jperio == 2 ) THEN
             idta( :    , 1    ) = idta( : ,  3  )   ;      zdta( :    , 1    ) = zdta( : ,  3  )
-            idta( :    ,jpjdta) = 0                 ;      zdta( :    ,jpjdta) =  0.e0
-            idta( 1    , :    ) = 0                 ;      zdta( 1    , :    ) =  0.e0
-            idta(jpidta, :    ) = 0                 ;      zdta(jpidta, :    ) =  0.e0
+            idta( :    ,jpjdta) = 0                 ;      zdta( :    ,jpjdta) =  0._wp
+            idta( 1    , :    ) = 0                 ;      zdta( 1    , :    ) =  0._wp
+            idta(jpidta, :    ) = 0                 ;      zdta(jpidta, :    ) =  0._wp
          ELSE
-            ih = 0                                  ;      zh = 0.e0
+            ih = 0                                  ;      zh = 0._wp
             IF( ln_sco )   ih = jpkm1               ;      IF( ln_sco )   zh = h_oce
             idta( :    , 1    ) = ih                ;      zdta( :    , 1    ) =  zh
@@ -379,5 +389,5 @@
          !                                            ! local domain level and meter bathymetries (mbathy,bathy)
          mbathy(:,:) = 0                                   ! set to zero extra halo points
-         bathy (:,:) = 0.e0                                ! (require for mpp case)
+         bathy (:,:) = 0._wp                               ! (require for mpp case)
          DO jj = 1, nlcj                                   ! interior values
             DO ji = 1, nlci
@@ -392,13 +402,12 @@
          !
          IF( ln_zco )   THEN                          ! zco : read level bathymetry 
-            CALL iom_open( 'bathy_level.nc', inum )  
-            CALL iom_get ( inum, jpdom_data, 'Bathy_level', bathy )
-            CALL iom_close (inum)
+            CALL iom_open ( 'bathy_level.nc', inum )  
+            CALL iom_get  ( inum, jpdom_data, 'Bathy_level', bathy )
+            CALL iom_close( inum )
             mbathy(:,:) = INT( bathy(:,:) )
             !                                                ! =====================
             IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN    ! ORCA R2 configuration
                !                                             ! =====================
-               IF( n_cla == 0 ) THEN
-                  !
+               IF( nn_cla == 0 ) THEN
                   ii0 = 140   ;   ii1 = 140                  ! Gibraltar Strait open 
                   ij0 = 102   ;   ij1 = 102                  ! (Thomson, Ocean Modelling, 1995)
@@ -409,5 +418,5 @@
                   END DO
                   IF(lwp) WRITE(numout,*)
-                  IF(lwp) WRITE(numout,*) '             orca_r2: Gibraltar strait open at i=',ii0,' j=',ij0
+                  IF(lwp) WRITE(numout,*) '      orca_r2: Gibraltar strait open at i=',ii0,' j=',ij0
                   !
                   ii0 = 160   ;   ii1 = 160                  ! Bab el mandeb Strait open
@@ -419,6 +428,5 @@
                   END DO
                   IF(lwp) WRITE(numout,*)
-                  IF(lwp) WRITE(numout,*) '             orca_r2: Bab el Mandeb strait open at i=',ii0,' j=',ij0
-                  !
+                  IF(lwp) WRITE(numout,*) '      orca_r2: Bab el Mandeb strait open at i=',ii0,' j=',ij0
                ENDIF
                !
@@ -427,32 +435,42 @@
          ENDIF
          IF( ln_zps .OR. ln_sco )   THEN              ! zps or sco : read meter bathymetry
-            CALL iom_open( 'bathy_meter.nc', inum ) 
-            CALL iom_get ( inum, jpdom_data, 'Bathymetry', bathy )
-            CALL iom_close (inum)
+            CALL iom_open ( 'bathy_meter.nc', inum ) 
+            CALL iom_get  ( inum, jpdom_data, 'Bathymetry', bathy )
+            CALL iom_close( inum )
             !                                                ! =====================
-           IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN    ! ORCA R2 configuration
-              !                                             ! =====================
-              IF( n_cla == 0 ) THEN
-                 !
-                 ii0 = 140   ;   ii1 = 140                  ! Gibraltar Strait open 
-                 ij0 = 102   ;   ij1 = 102                  ! (Thomson, Ocean Modelling, 1995)
+            IF( cp_cfg == "orca" .AND. jp_cfg == 1 ) THEN    ! ORCA R1 configuration
+               ii0 = 142   ;   ii1 = 142                     ! =====================
+               ij0 =  51   ;   ij1 =  53                     
+               DO ji = mi0(ii0), mi1(ii1)                    ! Close Halmera Strait
+                  DO jj = mj0(ij0), mj1(ij1)
+                     bathy(ji,jj) = 0._wp
+                  END DO
+               END DO
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) '      orca_r1: Halmera strait closed at i=',ii0,' j=',ij0,'->',ij1
+            ENDIF
+            !                                                ! =====================
+            IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN    ! ORCA R2 configuration
+               !                                             ! =====================
+              IF( nn_cla == 0 ) THEN
+                 ii0 = 140   ;   ii1 = 140                   ! Gibraltar Strait open 
+                 ij0 = 102   ;   ij1 = 102                   ! (Thomson, Ocean Modelling, 1995)
                  DO ji = mi0(ii0), mi1(ii1)
                     DO jj = mj0(ij0), mj1(ij1)
-                       bathy(ji,jj) = 284.e0
+                       bathy(ji,jj) = 284._wp
                     END DO
                  END DO
                  IF(lwp) WRITE(numout,*)
-                 IF(lwp) WRITE(numout,*) '             orca_r2: Gibraltar strait open at i=',ii0,' j=',ij0
+                 IF(lwp) WRITE(numout,*) '      orca_r2: Gibraltar strait open at i=',ii0,' j=',ij0
                  !
-                 ii0 = 160   ;   ii1 = 160                  ! Bab el mandeb Strait open
-                 ij0 = 88    ;   ij1 = 88                   ! (Thomson, Ocean Modelling, 1995)
+                 ii0 = 160   ;   ii1 = 160                   ! Bab el mandeb Strait open
+                 ij0 = 88    ;   ij1 = 88                    ! (Thomson, Ocean Modelling, 1995)
                  DO ji = mi0(ii0), mi1(ii1)
                     DO jj = mj0(ij0), mj1(ij1)
-                       bathy(ji,jj) = 137.e0
+                       bathy(ji,jj) = 137._wp
                     END DO
                  END DO
                  IF(lwp) WRITE(numout,*)
                  IF(lwp) WRITE(numout,*) '             orca_r2: Bab el Mandeb strait open at i=',ii0,' j=',ij0
-                 !
               ENDIF
               !
@@ -473,16 +491,22 @@
                DO ji = ncsi1(jl), ncsi2(jl)
                   mbathy(ji,jj) = 0                   ! suppress closed seas and lakes from bathymetry
-                  bathy (ji,jj) = 0.e0                
+                  bathy (ji,jj) = 0._wp               
                END DO
             END DO
          END DO
       ENDIF
-#if defined key_orca_lev10
-      !                                               ! ================= !
-      mbathy(:,:) = 10 * mbathy(:,:)                  !   key_orca_lev10  !
-      !                                               ! ================= !
-      IF( ln_zps .OR. ln_sco )   CALL ctl_stop( ' CAUTION: 300 levels only with level bathymetry' )
-#endif
-      !                         
+      !
+      !                                               ! =========================== !
+      !                                               !     set a minimum depth     !
+      !                                               ! =========================== !
+      IF( rn_hmin < 0._wp ) THEN    ;   ik = INT( rn_hmin ) + 1                                    ! from a nb of level
+      ELSE                          ;   ik = MINLOC( gdepw_0, mask = gdepw_0 > rn_hmin, dim = 1 )  ! from a depth
+      ENDIF
+      zhmin = gdepw_0(ik+1)                                                         ! minimum depth = ik+1 w-levels 
+      WHERE( bathy(:,:) <= 0._wp )   ;   bathy(:,:) = 0._wp                         ! min=0     over the lands
+      ELSE WHERE                     ;   bathy(:,:) = MIN(  zhmin , bathy(:,:)  )   ! min=zhmin over the oceans
+      END WHERE
+      IF(lwp) write(numout,*) 'Minimum ocean depth: ', zhmin, ' minimum number of ocean levels : ', ik
+      !
    END SUBROUTINE zgr_bat
 
@@ -601,5 +625,5 @@
       IF( lk_mpp ) THEN
          zbathy(:,:) = FLOAT( mbathy(:,:) )
-         CALL lbc_lnk( zbathy, 'T', 1. )
+         CALL lbc_lnk( zbathy, 'T', 1._wp )
          mbathy(:,:) = INT( zbathy(:,:) )
       ENDIF
@@ -641,5 +665,5 @@
          !   ... mono- or macro-tasking: T-point, >0, 2D array, no slab
          zbathy(:,:) = FLOAT( mbathy(:,:) )
-         CALL lbc_lnk( zbathy, 'T', 1. )
+         CALL lbc_lnk( zbathy, 'T', 1._wp )
          mbathy(:,:) = INT( zbathy(:,:) )
       ENDIF
@@ -672,4 +696,39 @@
 
 
+   SUBROUTINE zgr_bot_level
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE zgr_bot_level  ***
+      !!
+      !! ** Purpose :   defines the vertical index of ocean bottom (mbk. arrays)
+      !!
+      !! ** Method  :   computes from mbathy with a minimum value of 1 over land
+      !!
+      !! ** Action  :   mbkt, mbku, mbkv :   vertical indices of the deeptest 
+      !!                                     ocean level at t-, u- & v-points
+      !!                                     (min value = 1 over land)
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji, jj   ! dummy loop indices
+      REAL(wp), DIMENSION(jpi,jpj) ::   zmbk   ! 2D workspace 
+      !!----------------------------------------------------------------------
+      !
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) '    zgr_bot_level : ocean bottom k-index of T-, U-, V- and W-levels '
+      IF(lwp) WRITE(numout,*) '    ~~~~~~~~~~~~~'
+      !
+      mbkt(:,:) = MAX( mbathy(:,:) , 1 )    ! bottom k-index of T-level (=1 over land)
+      !                                     ! bottom k-index of W-level = mbkt+1
+      DO jj = 1, jpjm1                      ! bottom k-index of u- (v-) level
+         DO ji = 1, jpim1
+            mbku(ji,jj) = MIN(  mbkt(ji+1,jj  ) , mbkt(ji,jj)  )
+            mbkv(ji,jj) = MIN(  mbkt(ji  ,jj+1) , mbkt(ji,jj)  )
+         END DO
+      END DO
+      ! converte into REAL to use lbc_lnk ; impose a min value of 1 as a zero can be set in lbclnk 
+      zmbk(:,:) = REAL( mbku(:,:), wp )   ;   CALL lbc_lnk(zmbk,'U',1.)   ;   mbku  (:,:) = MAX( INT( zmbk(:,:) ), 1 )
+      zmbk(:,:) = REAL( mbkv(:,:), wp )   ;   CALL lbc_lnk(zmbk,'V',1.)   ;   mbkv  (:,:) = MAX( INT( zmbk(:,:) ), 1 )
+      !
+   END SUBROUTINE zgr_bot_level
+
+
    SUBROUTINE zgr_zco
       !!----------------------------------------------------------------------
@@ -678,39 +737,24 @@
       !! ** Purpose :   define the z-coordinate system
       !!
-      !! ** Method  :   set 3D coord. arrays to reference 1D array if lk_zco=T
+      !! ** Method  :   set 3D coord. arrays to reference 1D array 
       !!----------------------------------------------------------------------
       INTEGER  ::   jk
       !!----------------------------------------------------------------------
       !
-      IF( .NOT.lk_zco ) THEN
-         DO jk = 1, jpk
-            fsdept(:,:,jk) = gdept_0(jk)
-            fsdepw(:,:,jk) = gdepw_0(jk)
-            fsde3w(:,:,jk) = gdepw_0(jk)
-            fse3t (:,:,jk) = e3t_0(jk)
-            fse3u (:,:,jk) = e3t_0(jk)
-            fse3v (:,:,jk) = e3t_0(jk)
-            fse3f (:,:,jk) = e3t_0(jk)
-            fse3w (:,:,jk) = e3w_0(jk)
-            fse3uw(:,:,jk) = e3w_0(jk)
-            fse3vw(:,:,jk) = e3w_0(jk)
-         END DO
-      ENDIF
+      DO jk = 1, jpk
+         fsdept(:,:,jk) = gdept_0(jk)
+         fsdepw(:,:,jk) = gdepw_0(jk)
+         fsde3w(:,:,jk) = gdepw_0(jk)
+         fse3t (:,:,jk) = e3t_0(jk)
+         fse3u (:,:,jk) = e3t_0(jk)
+         fse3v (:,:,jk) = e3t_0(jk)
+         fse3f (:,:,jk) = e3t_0(jk)
+         fse3w (:,:,jk) = e3w_0(jk)
+         fse3uw(:,:,jk) = e3w_0(jk)
+         fse3vw(:,:,jk) = e3w_0(jk)
+      END DO
       !
    END SUBROUTINE zgr_zco
 
-#if defined key_zco
-   !!----------------------------------------------------------------------
-   !!   'key_zco' :                                              "pure" zco (gdep & e3 are 1D arrays)
-   !!----------------------------------------------------------------------
-   SUBROUTINE zgr_zps      ! Empty routine
-   END SUBROUTINE zgr_zps
-   SUBROUTINE zgr_sco      ! Empty routine
-   END SUBROUTINE zgr_sco
-
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option :                      zco, zps and/or sco available (gedp & e3 are 3D arrays)
-   !!----------------------------------------------------------------------
 
    SUBROUTINE zgr_zps
@@ -764,6 +808,7 @@
       REAL(wp) ::   ze3tp , ze3wp    ! Last ocean level thickness at T- and W-points
       REAL(wp) ::   zdepwp, zdepth   ! Ajusted ocean depth to avoid too small e3t
-      REAL(wp) ::   zmax, zmin       ! Maximum and minimum depth
+      REAL(wp) ::   zmax             ! Maximum depth
       REAL(wp) ::   zdiff            ! temporary scalar
+      REAL(wp) ::   zrefdep          ! temporary scalar
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprt   ! 3D workspace
       !!---------------------------------------------------------------------
